//      AVR
// ADC0 -    
// ADC1 -   
// PD2 -   

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h> 

//   2 
//     
unsigned char cw_dir[4]= 
{
0b00000001,
0b00000010,
0b00000100,
0b00001000
};

volatile unsigned char step_index, step, status;
volatile unsigned char ovftimes, step_limit;

//    0
ISR(TIMER0_OVF_vect)
{
static unsigned int count = 1;
count++;

if(count >= ovftimes) //  
{
cli(); //  
step++; //  - 

if(status) //  status = 1  
PORTB = cw_dir[step_index++];
else       //  
PORTB = 0x00;

if(step_index >= 4)
{
step_index = 0;
}

if(step > step_limit) //  -    (step_limit)  
{
status = 0;
}

if(step_limit > 200) //     200   
{
status = 1;
}

count = 0; //  
TCNT0 = 0; //    
sei(); //   
}
}

//    INT0
ISR(INT0_vect)
{
status = 1; //  
step = 1;
}

//   
uint16_t read_adc(unsigned char ch) 
{ 
ADMUX	&=	0xf0;
ADMUX |= ch; //   
     
ADCSRA |= (1 << ADSC); //   
while((ADCSRA & (1 << ADSC))); //   

return ADC; //    
}

int main(void)
{
DDRB = 0b00001111; // PB0, PB1, PB2, PB3 - 
PORTB = 0x00; // .   

DDRD = 0x00;
PORTD = 0xFF;

ADCSRA = (1 << ADEN) //  
      | (1 << ADPS2) //   64 (  125kHz)
	  | (1 << ADPS1);
ADMUX = 0x00; // ADC0 - ,   5 

GICR |= (1 << INT0); //   
MCUCR |= (1 << ISC01); //     INT0

TCCR0 |= (1 << CS01); //   8
TCNT0 = 0; //    
TIMSK |= (1 << TOIE0); //     0

ovftimes = 10; //  

sei(); //   

while(1) 
{

ovftimes = read_adc(0)/4; //   
step_limit = read_adc(1)/4;
_delay_ms(100);
}
}
